function potstring(ref,english,context,flags)
  io.write("#: ",ref,"\n",
    "msgctxt ",string.format("%q",context),"\n")
  if flags then for k,v in ipairs(flags) do
    if type(k)=="number" then
      io.write ("#, ",v,"\n")
    else
      io.write ("#, ",k," ",v,"\n")
    end
  end end
  io.write("msgid ",string.format("%q",english),"\n")
  io.write 'msgstr ""\n\n'
end

function outputtable(strings,path)
  for k,v in pairs(strings) do
    local path=path and
      (type(k)=="string" and path.."."..k or path.."["..k.."]")
      or k
    k=type(k)=="string" and k or '['..k..']'
    if type(v)=="table" then
    io.write("#. ",k,"={\n")
      outputtable(v,path)
      io.write"#. }\n\n"
    else
      potstring(k,v,path,
        path=="format" and {"c-format"} or nil)
    end
  end
end

dofile "strings.lua"

io.output "po/template.pot"

io.write [[
# SOME AUTOMATICALLY GENERATED BY A LUA SCRIPT TITLE.
# Copyright (C) 2009 Stuart P. Bentley
# This file is distributed under the same license as Sandpad.
# Stuart P. Bentley <stuart@testtrack4.com>, 2009.
#
#, fuzzy
msgid ""
msgstr ""
"Project-Id-Version: PACKAGE VERSION\n"
"Report-Msgid-Bugs-To: stuart@testtrack4.com\n"
]]
io.write('"POT-Creation-Date: ',os.date"!%Y-%m-%d %H:%M",
  string.format('%+03i00\\n"\n',(os.date"%H"-os.date"!%H")))
io.write[[
"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
"Language-Team: LANGUAGE <LL@li.org>\n"
"MIME-Version: 1.0\n"
"Content-Type: text/plain; charset=UTF-8\n"
"Content-Transfer-Encoding: 8bit\n"

]]

outputtable(strings,"strings")
